'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextArea = function (_Component) {
  _inherits(TextArea, _Component);

  function TextArea(props) {
    _classCallCheck(this, TextArea);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(TextArea).call(this, props));

    _this.state = { value: '' };

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(TextArea, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({ value: this.props.value });
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      return this.props.label ? _react2.default.createElement(
        'label',
        null,
        this.props.label
      ) : null;
    }
  }, {
    key: 'renderErrors',
    value: function renderErrors() {
      if (!this.props.errors) return null;

      return _react2.default.createElement(
        'p',
        null,
        this.props.errors.map(function (msg, i) {
          return _react2.default.createElement(
            'span',
            { key: i },
            msg
          );
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'form-group' },
        this.renderLabel(),
        _react2.default.createElement('textarea', { className: 'form-control',
          ref: 'textarea',
          name: this.props.name,
          value: this.state.value,
          onChange: this.handleChange }),
        this.renderErrors()
      );
    }
  }, {
    key: 'handleChange',
    value: function handleChange() {
      this.setState({ value: this.refs.textarea.value });
    }
  }]);

  return TextArea;
}(_react.Component);

TextArea.propTypes = {
  label: _react.PropTypes.string,
  name: _react.PropTypes.string.isRequired,
  value: _react.PropTypes.string,
  errors: _react.PropTypes.array
};

exports.default = TextArea;