import React , { Component, PropTypes } from 'react';

class Form extends Component {

  constructor(props) {
    super(props);

    this.handleSubmit = this.handleSubmit.bind(this);
  }

  render() {
    return (
      <form className={this.props.className}
            onSubmit={this.props.onSubmit}>
        {this.props.children}
      </form>
    );
  }

  handleSubmit() {
    this.props.onSubmit();
  }
}

Form.propTypes = {
  className: PropTypes.string,
  onSubmit: PropTypes.func
};

export default Form;