import React, { Component, PropTypes } from 'react';


class TextArea extends Component {

  constructor(props) {
    super(props);

    this.state = { value: '' };

    this.handleChange = this.handleChange.bind(this);
  }

  componentWillMount() {
    this.setState({ value: this.props.value });
  }

  renderLabel() {
    return this.props.label ? <label>{this.props.label}</label> : null;
  }

  renderErrors() {
    if (! this.props.errors) return null;

    return (
      <p>{this.props.errors.map((msg, i) => (<span key={i}>{msg}</span>))}</p>
    )
  }

  render() {
    return (
      <div className="form-group">
        {this.renderLabel()}
        <textarea className="form-control"
                  ref="textarea"
                  name={this.props.name}
                  value={this.state.value}
                  onChange={this.handleChange} />
        {this.renderErrors()}
      </div>
    );
  }

  handleChange() {
    this.setState({ value: this.refs.textarea.value });
  }
}

TextArea.propTypes = {
  label: PropTypes.string,
  name: PropTypes.string.isRequired,
  value: PropTypes.string,
  errors: PropTypes.array
};

export default TextArea;